Index: trunk/LMDZ.COMMON/libf/evolution/pem.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/evolution/pem.F90	(revision 3570)
+++ trunk/LMDZ.COMMON/libf/evolution/pem.F90	(revision 3571)
@@ -7,5 +7,5 @@
 !    I_e Initialization of the PEM variable and soil
 !    I_f Compute tendencies
-!    I_g Save the initial situation
+!    I_g Compute global surface pressure
 !    I_h Read the "startpem.nc"
 !    I_i Compute orbit criterion
@@ -40,15 +40,15 @@
 use pemredem,                   only: pemdem0, pemdem1
 use glaciers_mod,               only: flow_co2glaciers, flow_h2oglaciers, co2ice_flow, h2oice_flow, inf_h2oice_threshold, &
-                                      metam_h2oice_threshold, metam_co2ice_threshold, metam_h2oice, metam_co2ice
+                                      metam_h2oice_threshold, metam_co2ice_threshold, metam_h2oice, metam_co2ice, computeTcondCO2
 use stopping_crit_mod,          only: stopping_crit_h2o_ice, stopping_crit_co2
 use constants_marspem_mod,      only: alpha_clap_co2, beta_clap_co2, alpha_clap_h2o, beta_clap_h2o, m_co2, m_noco2
 use evol_ice_mod,               only: evol_co2_ice, evol_h2o_ice
-use comsoil_h_PEM,              only: soil_pem, ini_comsoil_h_PEM, end_comsoil_h_PEM, nsoilmx_PEM, mlayer_PEM, &
-                                      TI_PEM,               & ! soil thermal inertia
+use comsoil_h_PEM,              only: soil_pem, ini_comsoil_h_PEM, end_comsoil_h_PEM, nsoilmx_PEM, &
+                                      TI_PEM,               & ! Soil thermal inertia
                                       tsoil_PEM, layer_PEM, & ! Soil temp, number of subsurface layers, soil mid layer depths
                                       fluxgeo                 ! Geothermal flux for the PEM and PCM
 use adsorption_mod,             only: regolith_adsorption, adsorption_pem,        & ! Bool to check if adsorption, main subroutine
                                       ini_adsorption_h_PEM, end_adsorption_h_PEM, & ! Allocate arrays
-                                      co2_adsorbed_phys, h2o_adsorbed_phys        ! Mass of co2 and h2O adsorbed
+                                      co2_adsorbed_phys, h2o_adsorbed_phys          ! Mass of co2 and h2O adsorbed
 use time_evol_mod,              only: dt, evol_orbit_pem, Max_iter_pem, convert_years, year_bp_ini
 use orbit_param_criterion_mod,  only: orbit_param_criterion
@@ -62,8 +62,8 @@
 use compute_tend_mod,           only: compute_tend
 use info_PEM_mod,               only: info_PEM
-use nb_time_step_PCM_mod,       only: nb_time_step_PCM
+use get_timelen_PCM_mod,        only: get_timelen_PCM
 use pemetat0_mod,               only: pemetat0
 use read_data_PCM_mod,          only: read_data_PCM
-use recomp_tend_co2_slope_mod,  only: recomp_tend_co2
+use recomp_tend_co2_mod,        only: recomp_tend_co2
 use compute_soiltemp_mod,       only: compute_tsoil_pem, shift_tsoil2surf
 use writediagpem_mod,           only: writediagpem, writediagsoilpem
@@ -77,5 +77,5 @@
                                   albedodat, zmea, zstd, zsig, zgam, zthe,     &
                                   albedo_h2o_frost,frost_albedo_threshold,     &
-                                  emissiv, watercaptag, perennial_co2ice, emisice, albedice
+                                  emissiv, watercaptag, perennial_co2ice
     use dimradmars_mod,     only: totcloudfrac, albedo
     use dust_param_mod,     only: tauscaling
@@ -128,7 +128,7 @@
 real               :: time_phys    ! Same as in PCM
 real               :: ptimestep    ! Same as in PCM
-real               :: ztime_fin     ! Same as in PCM
-
-! Variables to read start.nc
+real               :: ztime_fin    ! Same as in PCM
+
+! Variables to read "start.nc"
 character(*), parameter :: start_name = "start.nc" ! Name of the file used to initialize the PEM
 
@@ -136,11 +136,13 @@
 real, dimension(ip1jm,llm)          :: vcov          ! vents covariants
 real, dimension(ip1jmp1,llm)        :: ucov          ! vents covariants
-real, dimension(ip1jmp1,llm)        :: teta          ! temperature potentielle
+real, dimension(ip1jmp1,llm)        :: teta          ! Potential temperature
 real, dimension(:,:,:), allocatable :: q             ! champs advectes
-real, dimension(ip1jmp1)            :: ps            ! pression au sol
-real, dimension(ip1jmp1)            :: ps0           ! pression au sol initiale
-real, dimension(:),     allocatable :: ps_start_PCM  ! (ngrid) surface pressure
-real, dimension(:,:),   allocatable :: ps_timeseries ! (ngrid x timelen) instantaneous surface pressure
-real, dimension(ip1jmp1,llm)        :: masse         ! masse d'air
+real, dimension(ip1jmp1)            :: ps_start_dyn  ! surface pressure in the start file (dynamic grid)
+real, dimension(:),     allocatable :: ps_start      ! surface pressure in the start file
+real, dimension(:),     allocatable :: ps_start0     ! surface pressure in the start file at the beginning
+real, dimension(:),     allocatable :: ps_avg        ! (ngrid) Averaged surface pressure
+real, dimension(:),     allocatable :: ps_dev        ! (ngrid x timelen) Surface pressure deviation
+real, dimension(:,:),   allocatable :: ps_timeseries ! (ngrid x timelen) Instantaneous surface pressure
+real, dimension(ip1jmp1,llm)        :: masse         ! Air mass
 real, dimension(ip1jmp1)            :: phis          ! geopotentiel au sol
 real                                :: time_0
@@ -157,35 +159,37 @@
 real, dimension(:), allocatable :: latitude      ! Latitude read in startfi_name and written in restartfi
 real, dimension(:), allocatable :: cell_area     ! Cell_area read in startfi_name and written in restartfi
-real                            :: Total_surface ! Total surface of the planet
+real                            :: total_surface ! Total surface of the planet
 
 ! Variables for h2o_ice evolution
 real, dimension(:,:),    allocatable  :: h2o_ice              ! h2o ice in the PEM
+real, dimension(:,:),    allocatable  :: d_h2oice             ! physical point x slope field: Tendency of evolution of perennial h2o ice
 real, dimension(:,:,:),  allocatable  :: min_h2o_ice          ! Minima of h2o ice at each point for the PCM years [kg/m^2]
 real                                  :: h2oice_ini_surf      ! Initial surface of sublimating h2o ice
-logical, dimension(:,:), allocatable  :: ini_h2oice_sublim    ! Logical array to know if h2o ice is sublimating
-real                                  :: global_avg_press_PCM ! constant: global average pressure retrieved in the PCM [Pa]
-real                                  :: global_avg_press_old ! constant: Global average pressure of initial/previous time step
-real                                  :: global_avg_press_new ! constant: Global average pressure of current time step
-real,   dimension(:,:),   allocatable :: zplev_new            ! Physical x Atmospheric field: mass of the atmospheric  layers in the pem at current time step [kg/m^2]
-real,   dimension(:,:),   allocatable :: zplev_PCM            ! same but retrieved from the PCM [kg/m^2]
-real,   dimension(:,:,:), allocatable :: zplev_new_timeseries ! Physical x Atmospheric x Time: same as zplev_new, but in times series [kg/m ^2]
-real,   dimension(:,:,:), allocatable :: zplev_old_timeseries ! same but with the time series, for oldest time step
+logical, dimension(:,:), allocatable  :: is_h2oice_sublim_ini ! Logical array to know if h2o ice is sublimating
+real                                  :: ps_avg_global_ini    ! constant: Global average pressure at initialization [Pa]
+real                                  :: ps_avg_global_old    ! constant: Global average pressure of previous time step
+real                                  :: ps_avg_global_new    ! constant: Global average pressure of current time step
+real,   dimension(:,:),   allocatable :: zplev_new            ! Grid points x Atmospheric field: mass of the atmospheric layers in the pem at current time step [kg/m^2]
+real,   dimension(:,:),   allocatable :: zplev_start0         ! Grid points x Atmospheric field: mass of the atmospheric layers in the start [kg/m^2]
+real,   dimension(:,:,:), allocatable :: zplev_timeseries_new ! Grid points x Atmospheric x Time: same as zplev_new, but in times series [kg/m ^2]
+real,   dimension(:,:,:), allocatable :: zplev_timeseries_old ! same but with the time series, for previous time step
 integer                               :: stopPEM              ! which criterion is reached? 0 = no stopping; 1 = h2o ice surf; 2 = no h2o ice; 3 = co2 ice surf; 4 = ps; 5 = orb param; 6 = end of simu
-real, save                            :: A, B, mmean          ! Molar mass: intermediate A, B for computations of the  mean molar mass of the layer [mol/kg]
-real,   dimension(:,:),   allocatable :: q_h2o_PEM_phys       ! Physics x Times: h2o mass mixing ratio computed in the PEM, first value comes from PCM [kg/kg]
+real                                  :: A, B, mmean          ! Molar mass: intermediate A, B for computations of the  mean molar mass of the layer [mol/kg]
+real,   dimension(:,:),   allocatable :: q_h2o_PEM_phys       ! Grid points x Times: h2o mass mixing ratio computed in the PEM, first value comes from PCM [kg/kg]
 integer                               :: timelen              ! # time samples
-real                                  :: ave                  ! intermediate varibale to compute average
-real,   dimension(:,:),   allocatable :: p                    ! Physics x Atmosphere: pressure to recompute and write in restart (ngrid,llmp1)
+real,   dimension(:,:),   allocatable :: p                    ! Grid points x Atmosphere: pressure to recompute and write in restart (ngrid,llmp1)
 real                                  :: extra_mass           ! Intermediate variables Extra mass of a tracer if it is greater than 1
 
 ! Variables for co2_ice evolution
-real,    dimension(:,:), allocatable :: co2_ice           ! co2 ice in the PEM
-logical, dimension(:,:), allocatable :: is_co2ice_ini     ! Was there co2 ice initially in the PEM?
-real,  dimension(:,:,:), allocatable :: min_co2_ice       ! Minimum of co2 ice at each point for the first year [kg/m^2]
-real                                 :: co2ice_ini_surf   ! Initial surface of sublimating co2 ice
-logical, dimension(:,:), allocatable :: ini_co2ice_sublim ! Logical array to know if co2 ice is sublimating
-real,    dimension(:,:), allocatable :: vmr_co2_PCM       ! Physics x Times co2 volume mixing ratio retrieve from the PCM [m^3/m^3]
-real,    dimension(:,:), allocatable :: vmr_co2_PEM_phys  ! Physics x Times co2 volume mixing ratio used in the PEM
-real,    dimension(:,:), allocatable :: q_co2_PEM_phys    ! Physics x Times co2 mass mixing ratio in the first layer computed in the PEM, first value comes from PCM [kg/kg]
+real,    dimension(:,:), allocatable :: co2_ice                ! co2 ice in the PEM
+real,    dimension(:,:), allocatable :: d_co2ice               ! physical point x slope field: Tendency of evolution of perennial co2 ice over a year
+real,    dimension(:,:), allocatable :: d_co2ice_ini           ! physical point x slope field: Tendency of evolution of perennial co2 ice over a year in the PCM
+logical, dimension(:,:), allocatable :: is_co2ice_ini          ! Was there co2 ice initially in the PEM?
+real,  dimension(:,:,:), allocatable :: min_co2_ice            ! Minimum of co2 ice at each point for the first year [kg/m^2]
+real                                 :: co2ice_sublim_surf_ini ! Initial surface of sublimating co2 ice
+logical, dimension(:,:), allocatable :: is_co2ice_sublim_ini   ! Logical array to know if co2 ice is sublimating
+real,    dimension(:,:), allocatable :: vmr_co2_PCM            ! Grid points x Times co2 volume mixing ratio retrieve from the PCM [m^3/m^3]
+real,    dimension(:,:), allocatable :: vmr_co2_PEM_phys       ! Grid points x Times co2 volume mixing ratio used in the PEM
+real,    dimension(:,:), allocatable :: q_co2_PEM_phys         ! Grid points x Times co2 mass mixing ratio in the first layer computed in the PEM, first value comes from PCM [kg/kg]
 
 ! Variables for stratification (layering) evolution
@@ -195,7 +199,4 @@
 
 ! Variables for slopes
-real, dimension(:,:),   allocatable :: d_co2ice          ! physical point x slope field: Tendency of evolution of perennial co2 ice over a year
-real, dimension(:,:),   allocatable :: d_co2ice_ini      ! physical point x slope field: Tendency of evolution of perennial co2 ice over a year in the PCM
-real, dimension(:,:),   allocatable :: d_h2oice          ! physical point x slope field: Tendency of evolution of perennial h2o ice
 real, dimension(:,:),   allocatable :: flag_co2flow      ! (ngrid,nslope): Flag where there is a CO2 glacier flow
 real, dimension(:),     allocatable :: flag_co2flow_mesh ! (ngrid)       : Flag where there is a CO2 glacier flow
@@ -204,22 +205,21 @@
 
 ! Variables for surface and soil
-real, dimension(:,:),     allocatable :: tsurf_avg                        ! Physic x SLOPE field: Averaged Surface Temperature [K]
-real, dimension(:,:,:),   allocatable :: tsoil_avg                        ! Physic x SOIL x SLOPE field: Averaged Soil Temperature [K]
-real, dimension(:,:,:),   allocatable :: tsurf_PCM_timeseries             ! ngrid x SLOPE x TIMES field: Surface Temperature in timeseries [K]
-real, dimension(:,:,:,:), allocatable :: tsoil_phys_PEM_timeseries        ! IG x SOIL x SLOPE x TIMES field: Non averaged Soil Temperature [K]
-real, dimension(:,:,:,:), allocatable :: tsoil_anom                       ! IG x SOIL x SLOPE x TIMES field: Amplitude between instataneous and yearly average soil temperature at the beginning [K]
-real, dimension(:,:),     allocatable :: tsurf_avg_yr1                    ! Physic x SLOPE field: Averaged Surface Temperature of first call of the PCM [K]
-real, dimension(:,:),     allocatable :: Tsoil_locslope                   ! Physic x Soil: Intermediate when computing Tsoil [K]
-real, dimension(:),       allocatable :: Tsurf_locslope                   ! Physic x Soil: Intermediate surface temperature to compute Tsoil [K]
-real, dimension(:,:,:,:), allocatable :: watersoil_density_timeseries     ! Physic x Soil x Slope x Times water soil density, time series [kg /m^3]
-real, dimension(:,:),     allocatable :: watersurf_density_avg            ! Physic x Slope, water surface density, yearly averaged [kg/m^3]
-real, dimension(:,:,:,:), allocatable :: watersoil_density_PEM_timeseries ! Physic x Soil x Slope x Times, water soil density, time series [kg/m^3]
-real, dimension(:,:,:),   allocatable :: watersoil_density_PEM_avg        ! Physic x Soil x Slopes, water soil density, yearly averaged [kg/m^3]
-real, dimension(:,:),     allocatable :: Tsurfavg_before_saved            ! Surface temperature saved from previous time step [K]
+real, dimension(:,:),     allocatable :: tsurf_avg                        ! Grid points x Slope field: Averaged surface temperature [K]
+real, dimension(:,:),     allocatable :: tsurf_dev                        ! ngrid x Slope x Times field: Surface temperature deviation [K]
+real, dimension(:,:),     allocatable :: tsurf_avg_yr1                    ! Grid points x Slope field: Averaged surface temperature of first call of the PCM [K]
+real, dimension(:,:,:),   allocatable :: tsoil_avg                        ! Grid points x Soil x Slope field: Averaged Soil Temperature [K]
+real, dimension(:,:),     allocatable :: tsoil_avg_old                    ! Grid points x Soil field: Averaged Soil Temperature at the previous time step [K]
+real, dimension(:,:,:),   allocatable :: tsoil_dev                        ! Grid points x Soil x Slope field: Soil temperature deviation [K]
+real, dimension(:,:,:,:), allocatable :: tsoil_timeseries                 ! Grid points x Soil x Slope x Times field: Soil temperature timeseries [K]
+real, dimension(:,:,:,:), allocatable :: tsoil_PEM_timeseries             ! Grid points x Soil x Slope x Times field: Soil temperature timeseries for PEM [K]
+real, dimension(:,:,:,:), allocatable :: watersoil_density_timeseries     ! Grid points x Soil x Slope x Times Water soil density timeseries [kg /m^3]
+real, dimension(:,:),     allocatable :: watersurf_density_avg            ! Grid points x Slope: Averaged  water surface density [kg/m^3]
+real, dimension(:,:,:,:), allocatable :: watersoil_density_PEM_timeseries ! Grid points x Soil x Slope x Times: Water soil density timeseries for PEM [kg/m^3]
+real, dimension(:,:,:),   allocatable :: watersoil_density_PEM_avg        ! Grid points x Soil x Slopes: Averaged water soil density [kg/m^3]
+real, dimension(:,:),     allocatable :: tsurf_avg_old                    ! Surface temperature saved from previous time step [K]
 real, dimension(:),       allocatable :: delta_co2_adsorbed               ! Physics: quantity of CO2 that is exchanged because of adsorption / desorption [kg/m^2]
 real, dimension(:),       allocatable :: delta_h2o_adsorbed               ! Physics: quantity of H2O that is exchanged because of adsorption / desorption [kg/m^2]
 real                                  :: totmassco2_adsorbed              ! Total mass of CO2 that is exchanged because of adsorption / desoprtion over the planets [kg]
 real                                  :: totmassh2o_adsorbed              ! Total mass of H2O that is exchanged because of adsorption / desoprtion over the planets [kg]
-logical                               :: bool_sublim                      ! logical to check if there is sublimation or not
 logical, dimension(:,:),  allocatable :: co2ice_disappeared               ! logical to check if a co2 ice reservoir already disappeared at a previous timestep
 real, dimension(:,:),     allocatable :: icetable_thickness_old           ! ngrid x nslope: Thickness of the ice table at the previous iteration [m]
@@ -233,5 +233,5 @@
 ! Some variables for the PEM run
 real, parameter :: year_step = 1   ! Timestep for the pem
-real            :: i_myear_leg       ! Number of iteration
+real            :: i_myear_leg     ! Number of iteration
 real            :: n_myear_leg     ! Maximum number of iterations before stopping
 real            :: i_myear         ! Global number of Martian years of the chained simulations
@@ -249,6 +249,6 @@
 
 #ifdef CPP_STD
-    real                                :: frost_albedo_threshold = 0.05 ! frost albedo threeshold to convert fresh frost to old ice
-    real                                :: albedo_h2o_frost              ! albedo of h2o frost
+    real                                :: frost_albedo_threshold = 0.05 ! Frost albedo threeshold to convert fresh frost to old ice
+    real                                :: albedo_h2o_frost              ! Albedo of h2o frost
     real, dimension(:),     allocatable :: tsurf_read_generic            ! Temporary variable to do the subslope transfert dimension when reading form generic
     real, dimension(:,:),   allocatable :: qsurf_read_generic            ! Temporary variable to do the subslope transfert dimension when reading form generic
@@ -286,5 +286,5 @@
 
 ! Loop variables
-integer :: i, l, ig, nnq, t, islope, ig_loop, islope_loop, isoil, icap
+integer :: i, l, ig, nnq, t, islope, ig_loop, islope_loop, isoil
 
 ! Elapsed time with system clock
@@ -379,8 +379,8 @@
     endif
 
-    call init_testphys1d('start1D.txt','startfi.nc',therestart1D,therestartfi,ngrid,nlayer,610.,nq,q,        &
-                         time_0,ps(1),ucov,vcov,teta,ndt,ptif,pks,dtphys,zqsat,dq,dqdyn,day0,day,gru,grv,w,  &
+    call init_testphys1d('start1D.txt','startfi.nc',therestart1D,therestartfi,ngrid,nlayer,610.,nq,q,            &
+                         time_0,ps_start_dyn(1),ucov,vcov,teta,ndt,ptif,pks,dtphys,zqsat,dq,dqdyn,day0,day,gru,grv,w,  &
                          play,plev,latitude,longitude,cell_area,atm_wat_profile,atm_wat_tau)
-    ps(2) = ps(1)
+    ps_start_dyn(2) = ps_start_dyn(1)
     nsplit_phys = 1
     day_step = steps_per_sol
@@ -391,12 +391,12 @@
 !------------------------
 ! I   Initialization
-!    I_b Read of the "start.nc" and starfi_evol.nc
+!    I_b Read of the "start.nc" and "starfi.nc"
 !------------------------
 ! I_b.1 Read "start.nc"
-allocate(ps_start_PCM(ngrid))
+allocate(ps_start(ngrid),ps_start0(ngrid))
 #ifndef CPP_1D
-    call dynetat0(start_name,vcov,ucov,teta,q,masse,ps,phis,time_0)
-
-    call gr_dyn_fi(1,iip1,jjp1,ngridmx,ps,ps_start_PCM)
+    call dynetat0(start_name,vcov,ucov,teta,q,masse,ps_start_dyn,phis,time_0)
+
+    call gr_dyn_fi(1,iip1,jjp1,ngridmx,ps_start_dyn,ps_start)
 
     call iniconst !new
@@ -412,15 +412,15 @@
     status = nf90_close(ncid)
 
-    call iniphysiq(iim,jjm,llm,(jjm-1)*iim+2,comm_lmdz,daysec,day_ini,dtphys/nsplit_phys,rlatu,rlatv,rlonu,rlonv,aire,cu,cv,rad,g,r,cpp,iflag_phys)
+    call iniphysiq(iim,jjm,llm,(jjm - 1)*iim + 2,comm_lmdz,daysec,day_ini,dtphys/nsplit_phys,rlatu,rlatv,rlonu,rlonv,aire,cu,cv,rad,g,r,cpp,iflag_phys)
 #else
-    ps_start_PCM(1) = ps(1)
+    ps_start(1) = ps_start_dyn(1)
 #endif
 
 ! Save initial surface pressure
-ps0 = ps
+ps_start0 = ps_start
 
 ! In the PCM, these values are given to the physic by the dynamic.
 ! Here we simply read them in the "startfi.nc" file
-status = nf90_open(startfi_name, NF90_NOWRITE, ncid)
+status = nf90_open(startfi_name,NF90_NOWRITE,ncid)
 
 status = nf90_inq_varid(ncid,"longitude",lonvarid)
@@ -537,22 +537,17 @@
 !------------------------
 ! First we read the evolution of water and co2 ice (and the mass mixing ratio) over the first year of the PCM run, saving only the minimum value
-call nb_time_step_PCM("data_PCM_Y1.nc",timelen)
-
-allocate(tsoil_avg(ngrid,nsoilmx,nslope))
+call get_timelen_PCM("data_PCM_Y1.nc",timelen)
+
 allocate(watersoil_density_PEM_avg(ngrid,nsoilmx_PEM,nslope))
 allocate(vmr_co2_PCM(ngrid,timelen))
-allocate(ps_timeseries(ngrid,timelen))
+allocate(ps_timeseries(ngrid,timelen),ps_avg(ngrid),ps_dev(ngrid))
 allocate(min_co2_ice(ngrid,nslope,2),min_h2o_ice(ngrid,nslope,2))
-allocate(tsurf_avg_yr1(ngrid,nslope))
-allocate(tsurf_avg(ngrid,nslope))
-allocate(tsurf_PCM_timeseries(ngrid,nslope,timelen))
-allocate(tsoil_anom(ngrid,nsoilmx,nslope,timelen))
+allocate(tsurf_avg_yr1(ngrid,nslope),tsurf_avg(ngrid,nslope),tsurf_avg_old(ngrid,nslope),tsurf_dev(ngrid,nslope))
+allocate(tsoil_avg(ngrid,nsoilmx,nslope),tsoil_dev(ngrid,nsoilmx,nslope))
+allocate(tsoil_timeseries(ngrid,nsoilmx,nslope,timelen),tsoil_PEM_timeseries(ngrid,nsoilmx_PEM,nslope,timelen))
 allocate(zshift_surf(ngrid,nslope),zlag(ngrid,nslope))
 allocate(q_co2_PEM_phys(ngrid,timelen),q_h2o_PEM_phys(ngrid,timelen))
 allocate(watersurf_density_avg(ngrid,nslope))
-allocate(watersoil_density_timeseries(ngrid,nsoilmx,nslope,timelen))
-allocate(Tsurfavg_before_saved(ngrid,nslope))
-allocate(tsoil_phys_PEM_timeseries(ngrid,nsoilmx_PEM,nslope,timelen))
-allocate(watersoil_density_PEM_timeseries(ngrid,nsoilmx_PEM,nslope,timelen))
+allocate(watersoil_density_timeseries(ngrid,nsoilmx,nslope,timelen),watersoil_density_PEM_timeseries(ngrid,nsoilmx_PEM,nslope,timelen))
 allocate(delta_co2_adsorbed(ngrid))
 allocate(co2ice_disappeared(ngrid,nslope))
@@ -561,16 +556,11 @@
 allocate(vmr_co2_PEM_phys(ngrid,timelen))
 
-write(*,*) "Downloading data Y1..."
-call read_data_PCM("data_PCM_Y1.nc",timelen,iim,jjm_value,ngrid,nslope,vmr_co2_PCM,ps_timeseries,min_co2_ice(:,:,1),min_h2o_ice(:,:,1), &
-                   tsurf_avg_yr1,tsoil_avg,tsurf_PCM_timeseries,tsoil_anom,q_co2_PEM_phys,q_h2o_PEM_phys,                     &
-                   watersurf_density_avg,watersoil_density_timeseries)
-write(*,*) "Downloading data Y1 done!"
-
-! Then we read the evolution of water and co2 ice (and the mass mixing ratio) over the second year of the PCM run, saving only the minimum value
-write(*,*) "Downloading data Y2..."
-call read_data_PCM("data_PCM_Y2.nc",timelen,iim,jjm_value,ngrid,nslope,vmr_co2_PCM,ps_timeseries,min_co2_ice(:,:,2),min_h2o_ice(:,:,2), &
-                   tsurf_avg,tsoil_avg,tsurf_PCM_timeseries,tsoil_anom,q_co2_PEM_phys,q_h2o_PEM_phys,                         &
-                   watersurf_density_avg,watersoil_density_timeseries)
-write(*,*) "Downloading data Y2 done!"
+call read_data_PCM("data_PCM_Y1.nc","data_PCM_Y2.nc",timelen,iim,jjm_value,ngrid,nslope,vmr_co2_PCM,ps_timeseries,ps_avg,tsurf_avg_yr1,tsurf_avg, &
+                   tsoil_avg,tsoil_timeseries,min_co2_ice,min_h2o_ice,q_co2_PEM_phys,q_h2o_PEM_phys,watersurf_density_avg,watersoil_density_timeseries)
+
+! Compute the deviation from the average
+ps_dev = ps_start - ps_avg
+tsurf_dev = tsurf - tsurf_avg
+tsoil_dev = tsoil - tsoil_avg(:,1:nsoilmx,:)
 
 !------------------------
@@ -586,18 +576,16 @@
 
 if (soil_pem) then
-    do t = 1,timelen
-        tsoil_anom(:,:,:,t) = tsoil_anom(:,:,:,t) - tsoil_avg ! compute anomaly between Tsoil(t) in the startfi - <Tsoil> to recompute properly tsoil in the restart
-    enddo
     call soil_settings_PEM(ngrid,nslope,nsoilmx_PEM,nsoilmx,inertiesoil,TI_PEM)
     tsoil_PEM(:,1:nsoilmx,:) = tsoil_avg
-    tsoil_phys_PEM_timeseries(:,1:nsoilmx,:,:) = tsoil_anom
     watersoil_density_PEM_timeseries(:,1:nsoilmx,:,:) = watersoil_density_timeseries
+    tsoil_PEM_timeseries(:,1:nsoilmx,:,:) = tsoil_timeseries
     do l = nsoilmx + 1,nsoilmx_PEM
         tsoil_PEM(:,l,:) = tsoil_avg(:,nsoilmx,:)
         watersoil_density_PEM_timeseries(:,l,:,:) = watersoil_density_timeseries(:,nsoilmx,:,:)
+        tsoil_PEM_timeseries(:,l,:,:) = tsoil_timeseries(:,nsoilmx,:,:)
     enddo
     watersoil_density_PEM_avg = sum(watersoil_density_PEM_timeseries,4)/timelen
 endif !soil_pem
-deallocate(tsoil_avg)
+deallocate(tsoil_avg,watersoil_density_timeseries,tsoil_timeseries)
 
 !------------------------
@@ -616,17 +604,11 @@
 !------------------------
 ! I   Initialization
-!    I_g Save the initial situation
-!------------------------
-allocate(zplev_PCM(ngrid,nlayer + 1))
-Total_surface = 0.
-do ig = 1,ngrid
-    Total_surface = Total_surface + cell_area(ig)
-    zplev_PCM(ig,:) = ap + bp*ps_start_PCM(ig)
-enddo
-global_avg_press_old = sum(cell_area*ps_start_PCM)/Total_surface
-global_avg_press_PCM = global_avg_press_old
-global_avg_press_new = global_avg_press_old
-write(*,*) "Total surface of the planet =", Total_surface
-write(*,*) "Initial global average pressure =", global_avg_press_PCM
+!    I_g Compute global surface pressure
+!------------------------
+total_surface = sum(cell_area)
+ps_avg_global_ini = sum(cell_area*ps_avg)/total_surface
+ps_avg_global_new = ps_avg_global_ini
+write(*,*) "Total surface of the planet =", total_surface
+write(*,*) "Initial global averaged pressure =", ps_avg_global_ini
 
 !------------------------
@@ -635,5 +617,4 @@
 !------------------------
 allocate(co2_ice(ngrid,nslope),h2o_ice(ngrid,nslope))
-
 allocate(stratif(ngrid,nslope))
 if (layering_algo) then
@@ -647,15 +628,15 @@
 call pemetat0("startpem.nc",ngrid,nsoilmx,nsoilmx_PEM,nslope,timelen,timestep,TI_PEM,tsoil_PEM,icetable_depth, &
               icetable_thickness,ice_porefilling,tsurf_avg_yr1,tsurf_avg,q_co2_PEM_phys,q_h2o_PEM_phys,        &
-              ps_timeseries,tsoil_phys_PEM_timeseries,d_h2oice,d_co2ice,co2_ice,h2o_ice,                       &
-              global_avg_press_PCM,watersurf_density_avg,watersoil_density_PEM_avg,co2_adsorbed_phys,         &
-              delta_co2_adsorbed,h2o_adsorbed_phys,delta_h2o_adsorbed,stratif)
+              ps_timeseries,ps_avg_global_ini,d_h2oice,d_co2ice,co2_ice,h2o_ice,watersurf_density_avg,         &
+              watersoil_density_PEM_avg,co2_adsorbed_phys,delta_co2_adsorbed,h2o_adsorbed_phys,delta_h2o_adsorbed,stratif)
+deallocate(tsurf_avg_yr1)
 
 ! We save the places where h2o ice is sublimating
 ! We compute the surface of h2o ice sublimating
-allocate(ini_co2ice_sublim(ngrid,nslope),ini_h2oice_sublim(ngrid,nslope),is_co2ice_ini(ngrid,nslope))
-co2ice_ini_surf = 0.
+allocate(is_co2ice_sublim_ini(ngrid,nslope),is_h2oice_sublim_ini(ngrid,nslope),is_co2ice_ini(ngrid,nslope))
+co2ice_sublim_surf_ini = 0.
 h2oice_ini_surf = 0.
-ini_co2ice_sublim = .false.
-ini_h2oice_sublim = .false.
+is_co2ice_sublim_ini = .false.
+is_h2oice_sublim_ini = .false.
 is_co2ice_ini = .false.
 co2ice_disappeared = .false.
@@ -664,14 +645,14 @@
         if (co2_ice(i,islope) > 0.) is_co2ice_ini(i,islope) = .true.
         if (d_co2ice(i,islope) < 0. .and. co2_ice(i,islope) > 0.) then
-            ini_co2ice_sublim(i,islope) = .true.
-            co2ice_ini_surf = co2ice_ini_surf + cell_area(i)*subslope_dist(i,islope)
+            is_co2ice_sublim_ini(i,islope) = .true.
+            co2ice_sublim_surf_ini = co2ice_sublim_surf_ini + cell_area(i)*subslope_dist(i,islope)
         endif
         if (d_h2oice(i,islope) < 0. .and. h2o_ice(i,islope) > 0.) then
-            ini_h2oice_sublim(i,islope) = .true.
+            is_h2oice_sublim_ini(i,islope) = .true.
             h2oice_ini_surf = h2oice_ini_surf + cell_area(i)*subslope_dist(i,islope)
         endif
     enddo
 enddo
-write(*,*) "Total initial surface of co2 ice sublimating (slope) =", co2ice_ini_surf
+write(*,*) "Total initial surface of co2 ice sublimating (slope) =", co2ice_sublim_surf_ini
 write(*,*) "Total initial surface of h2o ice sublimating (slope) =", h2oice_ini_surf
 
@@ -684,5 +665,5 @@
         do islope = 1,nslope
             do l = 1,nsoilmx_PEM - 1
-                if (l==1) then
+                if (l == 1) then
                    totmassco2_adsorbed = totmassco2_adsorbed + co2_adsorbed_phys(ig,l,islope)*(layer_PEM(l))* &
                                        subslope_dist(ig,islope)/cos(pi*def_slope_mean(islope)/180.)*cell_area(ig)
@@ -701,5 +682,4 @@
     write(*,*) "Tot mass of H2O in the regolith =", totmassh2o_adsorbed
 endif ! adsorption
-deallocate(tsurf_avg_yr1)
 
 !------------------------
@@ -741,7 +721,8 @@
 ! II.a.1. Compute updated global pressure
     write(*,*) "Recomputing the new pressure..."
+    ps_avg_global_old = ps_avg_global_new
     do i = 1,ngrid
         do islope = 1,nslope
-            global_avg_press_new = global_avg_press_new - CO2cond_ps*g*cell_area(i)*d_co2ice(i,islope)*subslope_dist(i,islope)/cos(pi*def_slope_mean(islope)/180.)/Total_surface
+            ps_avg_global_new = ps_avg_global_old - CO2cond_ps*g*cell_area(i)*d_co2ice(i,islope)*subslope_dist(i,islope)/cos(pi*def_slope_mean(islope)/180.)/total_surface
         enddo
     enddo
